local bit_band  = bit.band
local COMBATLOG_OBJECT_AFFILIATION_MINE		= COMBATLOG_OBJECT_AFFILIATION_MINE		or 0x00000001
local COMBATLOG_OBJECT_AFFILIATION_PARTY	= COMBATLOG_OBJECT_AFFILIATION_PARTY	or 0x00000002
local COMBATLOG_OBJECT_AFFILIATION_RAID		= COMBATLOG_OBJECT_AFFILIATION_RAID		or 0x00000004
local COMBATLOG_OBJECT_AFFILIATION_ALLINCLUSIVE = COMBATLOG_OBJECT_AFFILIATION_MINE+COMBATLOG_OBJECT_AFFILIATION_PARTY+COMBATLOG_OBJECT_AFFILIATION_RAID;
local COMBATLOG_REAL_PLAYER = COMBATLOG_OBJECT_TYPE_PLAYER + COMBATLOG_OBJECT_AFFILIATION_ALLINCLUSIVE;
local AceConfigDialog = LibStub("AceConfigDialog-3.0");
local GI = {};
local me = UnitGUID("player");

function GI_ParseCombatLog(_,_,ts, event, sourceGuid, sourceName, sourceFlags, destGuid, destName, destFlags, spellID, spellName, spellSchool, spellDamage, overkill)
    if not (bit_band(sourceFlags, COMBATLOG_REAL_PLAYER) ~= 0) or event ~= "SPELL_INTERRUPT" then return end
    if ( sourceGuid == me ) then
		SendChatMessage("Interrupted " .. destName .. " with " .. GetSpellLink(spellName) .. "!");
		GI_FadeOut(sourceName, destName, spellName, spellID);
	elseif ( destGuid == UnitGUID("target") ) then
		print("|cffff5522", sourceName, "interrupted", destName, "with", GetSpellLink(spellName), "|r");
		GI_FadeOut(sourceName, destName, spellName, spellID);
	end

end

local frame = CreateFrame("Frame", nil, UIParent);
frame:SetBackdrop({bgFile = "Interface/GLUES/loading",
										edgeFile = "Interface/GLUES/Common/TextPanel-Border",
										edgeSize = 8,
										insets = { left = 4, right = 4, top = 4, bottom = 4 }});
frame:SetBackdropColor(0.1,0.1,0.2,0.9);
frame:SetWidth(120);
frame:SetHeight(48);
frame:SetPoint("CENTER", UIParent, "CENTER", 0, -100);
frame:SetFrameStrata("DIALOG");
frame:Hide();
local icon = frame:CreateTexture("ARTWORK");
icon:SetPoint("CENTER", frame, "CENTER");
icon:SetWidth(32);
icon:SetHeight(32);

function GI_FadeOut(source, target, spell, sid)
	frame:Show();
	icon:SetTexture(GetSpellTexture(spell));
	icon:Show();
	frame.x = 3;
    frame:SetScript("OnUpdate",
        function(frame)
            if ( frame.x <= 0.01 ) then
                frame:SetScript("OnUpdate", nil);
				frame:Hide();
            else
                frame.x = frame.x - 0.04;
				if frame.x >= 1 then frame:SetAlpha(frame.x); end
            end
        end
    );
end


local frame = CreateFrame("Frame");
frame:SetParent(UIParent);frame:SetPoint("TOPLEFT");
frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
frame:SetScript("OnEvent", GI_ParseCombatLog);
